function [] = jpf2_balancer_2014_144987_3225_j8g99 ()
%**************************************************************************
%for each variable change
%%read in current values of bvariables
%change bvariables by 10%
%%write new bvariables to .txt
%%close all files
%%execute soldiv.exe
%wait 2 seconds
%%read new mvariables
%determine the ratio between change in mvariables and change in bvariables
%%update the bvariable change tabl

%create the balancing log vector and the balancing_log_row variable
balancing_log={'taue','hconf','taumhd','converged','lav','hrat',...
    'nebar_v2','converged','central_ne','alphan','ne0','converged',...
    'central_te','alphat2','te0','converged','tped_avg','cballoon',...
    'ped_temp','converged',};
balancing_log_row=1;
if balancing_log_row==1
else display 'error, balancing log row =|= 1'
    pause
end

%write balancing_log values to balancing_log.xls on correct line
first_cell=strcat('A',num2str(balancing_log_row));
xlswrite('balancing_log.xls',balancing_log(balancing_log_row,:),1,...
    first_cell);

balancing_log_row=balancing_log_row+1;
if balancing_log_row==2
else display 'error, balancing log row =|= 2'
    pause
end
%%input target variable values here
balancing_log{balancing_log_row,3}=3.93; %taumhd=5
%nebar_v2 and ne0 should be in Ye20 format, e.g. 1.2e20 <=> 1.2
balancing_log{balancing_log_row,7}=0.228; %nebar_v2=5;
balancing_log{balancing_log_row,11}=0.39; %ne0=5
%temperatures should be in eV
balancing_log{balancing_log_row,15}=2300; %te0=500
balancing_log{balancing_log_row,19}=625; %ped_temp=500

%do an initial run
!soldivjpf2.exe
pause(2)

%read initial run's balancing and moving variables into the balancing_log
[bvariables,mvariables]=jpf2_balancer_2014_GTEDGE_runner(0,0);

for i=1:5
     balancing_log{balancing_log_row,(-2+4*i)}=bvariables(i);
     balancing_log{balancing_log_row,(-3+4*i)}=mvariables(i);
     balancing_log{balancing_log_row,4*i}=0;
end

%write balancing_log values to balancing_log.xls on correct line
first_cell=strcat('A',num2str(balancing_log_row));
xlswrite('balancing_log.xls',balancing_log(balancing_log_row,:),1,...
    first_cell);

display 'beginning for loop line 66'
setup_iterations=0;
%call ratio determinant routine
for i=1:5
    balancing_log_row=balancing_log_row+1;
    %increase the previous balancing value by 10%
    for j=1:5
        if i==j
            if i==3 
                balancing_log{balancing_log_row,(-2+4*j)}=balancing_log{...
                    balancing_log_row-1,(-2+4*j)}*1.1;
            else
                balancing_log{balancing_log_row,(-2+4*j)}=balancing_log{...
                    balancing_log_row-1,(-2+4*j)}*1.1;
            end
        else
            balancing_log{balancing_log_row,(-2+4*j)}=balancing_log{...
                balancing_log_row-1,(-2+4*j)};
        end
    end
    %write the new value to balance.txt
    [bvariables,mvariables] = jpf2_balancer_2014_GTEDGE_runner...
        (i,balancing_log{balancing_log_row,(-2+4*i)});
    %write new values to balancing_log
    for j=1:5
        balancing_log{balancing_log_row,(-3+4*j)}=mvariables(j);
        balancing_log{balancing_log_row,(-1+4*j)}=balancing_log{...
            balancing_log_row-1,(-1+4*j)};
    end
%    %take moving variable change to balancing variable change ratio
%    bvariable_mvariable_ratio(i)=(balancing_log{balancing_log_row,(-2+4*...
%        i)}-balancing_log{balancing_log_row-1,(-2+4*i)})/((balancing_log...
%        {balancing_log_row,(-3+4*i)}-balancing_log{balancing_log_row-1,...
%        (-3+4*i)}));
    %write balancing_log values to balancing_log.xls on correct line
    first_cell=strcat('A',num2str(balancing_log_row));
    xlswrite('balancing_log.xls',balancing_log(balancing_log_row,:),1,...
    first_cell);
end
%bvariable_mvariable_ratio

%There are nine nested iterative loops here, one for each variable, and one
%for each loop.  The outer loop is over all the variables; the density loop
%is over taue, lav, and central ne; the e20 loop is over lav and central ne
%; and the temperature loop is over central te and pedestal temperature.
%Then there is a loop for taue, lav, central ne, central te, and pedestal
%temperature.
%
%The convergence and iteration order is as follows: First is the e20 loop, 
%where the two variables will be converged; Second is the full density;
%loop; and Third is the temperature loop.
%
%There are nine convergence variables, and four convergence vectors.
%The variables are one for each loop (outer, density, temperature, e20,
%taue, lav, central ne, central te, pedestal temperature), and the vectors
%are for the outer, density, e20, and temperature loops.
%
%convergence variables
outer_convergence=0;
density_convergence=0;
temperature_convergence=0;
e20_convergence=0;
taue_convergence=0;
lav_convergence=0;
ne0_convergence=0;
te0_convergence=0;
ped_temp_convergence=0;

%convergence vectors
convergence_vector=zeros(1,5);
density_convergence_vector=zeros(1,3);
temperature_convergence_vector=zeros(1,2);
e20_convergence_vector=zeros(1,2);

%keep track of iterations
outer_iterations=0;
density_iterations=0;
temperature_iterations=0;
e20_iterations=0;
%iterations_vector
iterations_vector={'outer_iterations',0;'density_iterations',0;...
    'taue',0;'e20_iterations',0;'lav',0;'centralne',0;...
    'temperature_iterations',0;'centralte',0;'ped_temp',0}

diag_1=0;
diag_2=0;
diag_3=0;
diag_4=0;
diag_5=0;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%11111111111111111111111111111111111111111111111111111111111111111111111111
%begin outer convergence
%11111111111111111111111111111111111111111111111111111111111111111111111111
%set convergence_vector for all five variables
for i=1:5
    gvariable=balancing_log{balancing_log_row,-1+4*i};
    mvariable=balancing_log{balancing_log_row,(-3+4*i)};
    %subroutine determines if the moving variable is within a third sig fig
    %of the goalvariable
    %subroutine throws an error if the values of the goal variables are out
    %of line
    [converged_ans]=jpf2_balancer_2014_convergence_checker(gvariable...
        ,mvariable,i);
    %if converged, say so in the convergence vector
    if converged_ans==1
        convergence_vector(i)=1;
        balancing_log{balancing_log_row,4*i}=1;
    end
end
%check for convergence
if convergence_vector(1)==1 && convergence_vector(2)==1 && ...
        convergence_vector(3)==1 && convergence_vector(4)==1 && ...
        convergence_vector(5)==1
    outer_convergence=1
else
    outer_convergence=0;
end
%check for outer convergence, if outer converges without any iteration,
%throw an error
if outer_convergence==1
    display 'error, outer convergence=1 before iteration'
    pause
end

while outer_convergence==0
    %2222222222222222222222222222222222222222222222222222222222222222222222
    %begin density convergence
    %2222222222222222222222222222222222222222222222222222222222222222222222
    %check density convergence
    %set density_convergence_vector for all three variables
    for i=1:3
        gvariable=balancing_log{balancing_log_row,-1+4*i};
        mvariable=balancing_log{balancing_log_row,(-3+4*i)};
        [converged_ans]=jpf2_balancer_2014_convergence_checker(gvariable...
            ,mvariable,i);
        %if converged, say so in the density convergence vector
        if converged_ans==1
            density_convergence_vector(i)=1;
        else
            density_convergence_vector(i)=0;
        end
    end
    %check for convergence
    if density_convergence_vector(1)==1 && density_convergence_vector(2)...
            ==1 && density_convergence_vector(3)==1 
        density_convergence=1
    else
        density_convergence=0;
    end
    
    %iterate and converge density variables
    while density_convergence==0
        %iterate and converge taue first, then lav and central ne together
        
        %333333333333333333333333333333333333333333333333333333333333333333
        %begin taue convergence
        %333333333333333333333333333333333333333333333333333333333333333333
        %check taue convergence
        gvariable=balancing_log{balancing_log_row,3};
        mvariable=balancing_log{balancing_log_row,1};
        [converged_ans]=jpf2_balancer_2014_convergence_checker(gvariable...
            ,mvariable,1);
        if converged_ans==1
            taue_convergence=1
            balancing_log{balancing_log_row,4}=taue_convergence;
        else
            taue_convergence=0;
        end
        %end taue convergence check
        %
        %start taue loop
        iterations_vector{3,2}=0;
        while taue_convergence==0
            gvariable=balancing_log{balancing_log_row,3};
            mvariable=balancing_log{balancing_log_row,1};
            [increment,indicator]=jpf2_balancer_2014_incrementer(...
                gvariable,mvariable,1)
            balancing_log_row=balancing_log_row+1;
            if iterations_vector{3,2}==0;
                balancing_log{balancing_log_row,2}=balancing_log{...
                    balancing_log_row-1,2}*1.1;
            else
            balancing_log{balancing_log_row,2}=balancing_log{...
                balancing_log_row-1,2}*increment;
            current_val=balancing_log{balancing_log_row,2}
                if or(current_val<0.1,current_val>100)
                    display 'error, hconf is greater than 100 or less than 0.1'
%                    pause
                end
            end
            if diag_1==0
                hconf_taue=[];
                for i=1:1:100
                    [bvariables,mvariables]=jpf2_balancer_2014_GTEDGE_runner...
                        (1,i);
                    hconf_taue=[hconf_taue;i,mvariables(1)];
                    [i,mvariables(1)];
                end
                xlswrite('diagnostic_vector.xls',hconf_taue,'A1')
                diag_1=1
            else
            end
            %run GTEDGE
            [bvariables,mvariables] = jpf2_balancer_2014_GTEDGE_runner...
                (1,balancing_log{balancing_log_row,2});
            if or(mvariables(1)>50,mvariables(1)<0.05)
                display 'error, taue is greater than 50 or less than 0.05'
%                pause
            end
            for i=1:5
                balancing_log{balancing_log_row,-3+4*i}=mvariables(i);
                balancing_log{balancing_log_row,-1+4*i}=balancing_log{...
                    balancing_log_row-1,-1+4*i};
                if i==1
                    if balancing_log{balancing_log_row,2}<bvariables(1)*...
                            1.01 && balancing_log{balancing_log_row,2}>...
                            bvariables(1)*0.99
                    else display 'error - discrepancy between balancing_log and balancing.txt - line 259'
%                        pause
                    end
                else
                    balancing_log{balancing_log_row,-2+4*i}=bvariables(i);
                end
            end
            %check taue convergence
            gvariable=balancing_log{balancing_log_row,3};
            mvariable=balancing_log{balancing_log_row,1};
            [converged_ans]=jpf2_balancer_2014_convergence_checker(...
                gvariable,mvariable,1);
            if converged_ans==1
                taue_convergence=1
                balancing_log{balancing_log_row,4}=1;
            else
                taue_convergence=0;
            end
            %write balancing_log values to balancing_log.xls on correct line
            first_cell=strcat('A',num2str(balancing_log_row));
            xlswrite('balancing_log.xls',balancing_log(balancing_log_row...
                ,:),1,first_cell);
            %end taue convergence check
            iterations_vector{3,2}=iterations_vector{3,2}+1
        end
        %333333333333333333333333333333333333333333333333333333333333333333
        %end taue convergence
        %333333333333333333333333333333333333333333333333333333333333333333

        %444444444444444444444444444444444444444444444444444444444444444444
        %begin e20 convergence
        %444444444444444444444444444444444444444444444444444444444444444444
        %check e20 convergence
        %set e20_convergence_vector for both variables
        for i=2:3
            gvariable=balancing_log{balancing_log_row,-1+4*i};
            mvariable=balancing_log{balancing_log_row,(-3+4*i)};
            [converged_ans]=jpf2_balancer_2014_convergence_checker(gvariable...
                ,mvariable,i);
            %if converged, say so in the e20 convergence vector
            if converged_ans==1
                e20_convergence_vector(i-1)=1;
            else
                e20_convergence_vector(i-1)=0;
            end
        end
        %check for convergence
        if e20_convergence_vector(1)==1 && e20_convergence_vector(2)==1
            e20_convergence=1
        else
            e20_convergence=0;
        end
        while e20_convergence==0
            %55555555555555555555555555555555555555555555555555555555555555
            %begin lav convergence
            %55555555555555555555555555555555555555555555555555555555555555
            %check lav convergence
            gvariable=balancing_log{balancing_log_row,7};
            mvariable=balancing_log{balancing_log_row,5};
            [converged_ans]=jpf2_balancer_2014_convergence_checker(gvariable...
                ,mvariable,2);
            if converged_ans==1
                lav_convergence=1
                balancing_log{balancing_log_row,8}=lav_convergence;
            else
                lav_convergence=0;
            end
            %end lav convergence check
            %
            %start taue loop
            iterations_vector{5,2}=0;
            while lav_convergence==0
                gvariable=balancing_log{balancing_log_row,7};
                mvariable=balancing_log{balancing_log_row,5};
                [increment,indicator]=jpf2_balancer_2014_incrementer(...
                    gvariable,mvariable,2);
                balancing_log_row=balancing_log_row+1;
                if iterations_vector{5,2}==0;
                    balancing_log{balancing_log_row,6}=balancing_log{...
                        balancing_log_row-1,6}*1.1;
                else
                    balancing_log{balancing_log_row,6}=balancing_log{...
                        balancing_log_row-1,6}*increment;
                    current_val=balancing_log{balancing_log_row,6}
                    if or(current_val<0.01,current_val>1)
                        display 'error, hrat is greater than 1 or less than 0.01'
%                        pause
                    end
                end
                if diag_2==0
                    hrat_lav=[];
                    for i=0.01:0.1:10
                        [bvariables,mvariables]=jpf2_balancer_2014_GTEDGE_runner...
                            (2,i);
                        hrat_lav=[hrat_lav;i,mvariables(2)];
                        [i,mvariables(2)];
                    end
                    xlswrite('diagnostic_vector.xls',hrat_lav,'C1')
                    diag_2=1
                else
                end
                %run GTEDGE
                [bvariables,mvariables]=jpf2_balancer_2014_GTEDGE_runner...
                    (2,balancing_log{balancing_log_row,6});
                if or(mvariables(2)>50,mvariables(2)<0.005)
                    display 'error, lav is greater than 50e20 or less than 0.005e20'
%                    pause
                end
                for i=1:5
                    balancing_log{balancing_log_row,-3+4*i}=mvariables(i);
                    balancing_log{balancing_log_row,-1+4*i}=balancing_log{...
                    balancing_log_row-1,-1+4*i};
                    if i==2
                        if balancing_log{balancing_log_row,6}<bvariables(2)*...
                            1.01 && balancing_log{balancing_log_row,6}>...
                            bvariables(2)*0.99
                        else display 'error - discrepancy between balancing_log and balancing.txt - line 259'
                        end
                    else
                        balancing_log{balancing_log_row,-2+4*i}=bvariables(i);
                    end
                end
                %check lav convergence
                gvariable=balancing_log{balancing_log_row,7};
                mvariable=balancing_log{balancing_log_row,5};
                [converged_ans]=jpf2_balancer_2014_convergence_checker(...
                    gvariable,mvariable,2);
                if converged_ans==1
                    lav_convergence=1
                    balancing_log{balancing_log_row,8}=1;
                else
                    lav_convergence=0;
                end
                %write balancing_log values to balancing_log.xls on correct line
                first_cell=strcat('A',num2str(balancing_log_row));
                xlswrite('balancing_log.xls',balancing_log(balancing_log_row...
                    ,:),1,first_cell);
                %end lav convergence check
                iterations_vector{5,2}=iterations_vector{5,2}+1
            end
            %55555555555555555555555555555555555555555555555555555555555555
            %end lav convergence
            %55555555555555555555555555555555555555555555555555555555555555
            %
            %66666666666666666666666666666666666666666666666666666666666666
            %begin ne0 convergence
            %66666666666666666666666666666666666666666666666666666666666666
            %check ne0 convergence
            gvariable=balancing_log{balancing_log_row,11};
            mvariable=balancing_log{balancing_log_row,9};
            [converged_ans]=jpf2_balancer_2014_convergence_checker(gvariable...
                ,mvariable,3);
            if converged_ans==1
                ne0_convergence=1
                balancing_log{balancing_log_row,12}=ne0_convergence;
            else
                ne0_convergence=0;
            end
            %end ne0 convergence check
            %
            %start ne0 loop
            iterations_vector{6,2}=0;
            while ne0_convergence==0
                gvariable=balancing_log{balancing_log_row,11};
                mvariable=balancing_log{balancing_log_row,9};
                [increment,indicator]=jpf2_balancer_2014_incrementer(...
                    gvariable,mvariable,3);
                balancing_log_row=balancing_log_row+1;
                if diag_3==0
                    alphan_centralne=[];
                    for i=-5:0.1:7
                        [bvariables,mvariables]=jpf2_balancer_2014_GTEDGE_runner...
                            (3,i);
                        alphan_centralne=[alphan_centralne;i,mvariables(3)];
                        [i,mvariables(3)];
                    end
                    xlswrite('diagnostic_vector.xls',alphan_centralne,'E1')
                    diag_3=1
                else
                end
                prev_alphan_bvar=balancing_log{balancing_log_row-1,10};
                if iterations_vector{6,2}==0 && prev_alphan_bvar>4 &&...
                        prev_alphan_bvar<7;
                    balancing_log{balancing_log_row,10}=prev_alphan_bvar...
                        *1.1;
                elseif and(prev_alphan_bvar>4,prev_alphan_bvar<7)
                    difference_alphan=7-prev_alphan_bvar;
                    inv_difference_alphan=prev_alphan_bvar-4;
                    if increment>1
                        increment=increment-1
                    else increment=1-increment
                    end
                    if balancing_log{balancing_log_row-1,11}>...
                            balancing_log{balancing_log_row-1,9}
                        balancing_log{balancing_log_row,10}=...
                            prev_alphan_bvar+difference_alphan*increment*0.1;
                    else balancing_log{balancing_log_row,10}=...
                            prev_alphan_bvar-inv_difference_alphan*increment*0.1;
                    end
                    current_val=balancing_log{balancing_log_row,10}
                    if or(current_val<4,current_val>7.5)
                        display 'error, alphan is greater than 7.5 or less than 4'
%                        pause
                    end
                end
                
%                if or(current_val<4,current_val>7)
%                    balancing_log{balancing_log_row,10}=4.5
%                    display 'had to reset alphan!'
%                end

                %run GTEDGE
                [bvariables,mvariables]=jpf2_balancer_2014_GTEDGE_runner...
                    (3,current_val);
                if or(mvariables(3)>50,mvariables(3)<0.01)
                    display 'error, centralne is greater than 50e20 or less than 0.01e20'
%                    pause
                end
                for i=1:5
                    balancing_log{balancing_log_row,-3+4*i}=mvariables(i);
                    balancing_log{balancing_log_row,-1+4*i}=balancing_log{...
                    balancing_log_row-1,-1+4*i};
                    if i==3
                    else
                        balancing_log{balancing_log_row,-2+4*i}=bvariables(i);
                    end
                end
                %check ne0 convergence
                gvariable=balancing_log{balancing_log_row,11};
                mvariable=balancing_log{balancing_log_row,9};
                [converged_ans]=jpf2_balancer_2014_convergence_checker(...
                    gvariable,mvariable,3);
                if converged_ans==1
                    ne0_convergence=1
                    balancing_log{balancing_log_row,12}=1;
                else
                    ne0_convergence=0;
                end
                %write balancing_log values to balancing_log.xls on correct line
                first_cell=strcat('A',num2str(balancing_log_row));
                xlswrite('balancing_log.xls',balancing_log(balancing_log_row...
                    ,:),1,first_cell);
                %end ne0 convergence check
                iterations_vector{6,2}=iterations_vector{6,2}+1
            end
            %    
            %66666666666666666666666666666666666666666666666666666666666666
            %end ne0 convergence
            %66666666666666666666666666666666666666666666666666666666666666
            %check e20 convergence
            %set e20_convergence_vector for both variables
            for i=2:3
                gvariable=balancing_log{balancing_log_row,-1+4*i};
                mvariable=balancing_log{balancing_log_row,(-3+4*i)};
                [converged_ans]=jpf2_balancer_2014_convergence_checker(...
                    gvariable,mvariable,i);
                %if converged, say so in the e20 convergence vector
                if converged_ans==1
                    e20_convergence_vector(i-1)=1;
                else
                    e20_convergence_vector(i-1)=0;
                end
            end
            %check for convergence
            if e20_convergence_vector(1)==1 && e20_convergence_vector(2)==1
                e20_convergence=1
            else
                e20_convergence=0;
            end
        iterations_vector{4,2}=iterations_vector{4,2}+1
        end
        %444444444444444444444444444444444444444444444444444444444444444444
        %end e20 convergence
        %444444444444444444444444444444444444444444444444444444444444444444
        %
        %determine if density variables are all converged
        for i=1:3
            gvariable=balancing_log{balancing_log_row,-1+4*i};
            mvariable=balancing_log{balancing_log_row,(-3+4*i)};
            [converged_ans]=jpf2_balancer_2014_convergence_checker(...
                gvariable,mvariable,i);
            %if converged, say so in the convergence vector
            if converged_ans==1
                density_convergence_vector(i)=1;
            else density_convergence_vector(i)=0;
            end
        end
        if density_convergence_vector(1)==1 && ...
            density_convergence_vector(2)==1 && ...
            density_convergence_vector(3)==1
            density_convergence=1
        else density_convergence=0;
        end
        iterations_vector{2,2}=iterations_vector{2,2}+1
    end
    %2222222222222222222222222222222222222222222222222222222222222222222222
    %end density convergence
    %2222222222222222222222222222222222222222222222222222222222222222222222
    
    %7777777777777777777777777777777777777777777777777777777777777777777777
    %begin temperature convergence
    %7777777777777777777777777777777777777777777777777777777777777777777777
    %check temperature convergence
    %set temperature_convergence_vector for both variables
    for i=4:5
        gvariable=balancing_log{balancing_log_row,-1+4*i};
        mvariable=balancing_log{balancing_log_row,(-3+4*i)};
        [converged_ans]=jpf2_balancer_2014_convergence_checker(gvariable...
            ,mvariable,i);
        %if converged, say so in the e20 convergence vector
        if converged_ans==1
            temperature_convergence_vector(i-3)=1;
        else temperature_convergence_vector(i-3)=0;
        end
    end
    %check for convergence
    if temperature_convergence_vector(1)==1 && temperature_convergence_vector(2)==1
        temperature_convergence=1
    else
        temperature_convergence=0;
    end
    while temperature_convergence==0
        %88888888888888888888888888888888888888888888888888888888888888
        %begin te0 convergence
        %88888888888888888888888888888888888888888888888888888888888888
        %check te0 convergence
        gvariable=balancing_log{balancing_log_row,15};
        mvariable=balancing_log{balancing_log_row,13};
        [converged_ans]=jpf2_balancer_2014_convergence_checker(gvariable...
           ,mvariable,4);
        if converged_ans==1
            te0_convergence=1
            balancing_log{balancing_log_row,16}=te0_convergence;
        else
            te0_convergence=0;
        end
        %end te0 convergence check
        %start te0 loop
        iterations_vector{8,2}=0;
        while te0_convergence==0
                gvariable=balancing_log{balancing_log_row,15};
                mvariable=balancing_log{balancing_log_row,13};
                [increment,indicator]=jpf2_balancer_2014_incrementer(...
                    gvariable,mvariable,4);
                balancing_log_row=balancing_log_row+1;
                if and(increment>1,balancing_log{balancing_log_row-1,14}<0)
                    increment=increment-1
                    flag1=1;
                else increment=1-increment
                    flag1=0;
                end
                if iterations_vector{8,2}==0;
                    balancing_log{balancing_log_row,14}=balancing_log{...
                        balancing_log_row-1,14}*1.1;
                else
                    if flag1==1
                        balancing_log{balancing_log_row,14}=balancing_log{...
                            balancing_log_row-1,14}*(1-increment*0.01);
                    else balancing_log{balancing_log_row,14}=balancing_log{...
                            balancing_log_row-1,14}*(1+increment*0.01)
                    end
                    current_val=balancing_log{balancing_log_row,14};
                    if or(current_val<-1.5,current_val>-0.1)
                        display 'error, alphat2 is greater than -0.1 or less than -1.5'
%                        pause
                    end
                end
                if diag_4==0
                    alphat2_centralte=[];
                    for i=-2.01:0.05:2
                        [bvariables,mvariables]=jpf2_balancer_2014_GTEDGE_runner...
                            (4,i);
                        alphat2_centralte=[alphat2_centralte;i,mvariables(4)];
                        [i,mvariables(4)];
                    end
                    xlswrite('diagnostic_vector.xls',alphat2_centralte,'G1')
                    diag_4=1
                else
                end
                %run GTEDGE
                [bvariables,mvariables]=jpf2_balancer_2014_GTEDGE_runner...
                    (4,balancing_log{balancing_log_row,14});
                if or(mvariables(4)>50000,mvariables(4)<10)
                    display 'error, centralte is greater than 50 kev or less than 0.01 kev'
%                    pause
                end
                for i=1:5
                    balancing_log{balancing_log_row,-3+4*i}=mvariables(i);
                    balancing_log{balancing_log_row,-1+4*i}=balancing_log{...
                    balancing_log_row-1,-1+4*i};
                    if i==4
                        if balancing_log{balancing_log_row,14}<bvariables(4)*...
                            1.01 && balancing_log{balancing_log_row,14}>...
                            bvariables(4)*0.99
                        else display 'error - discrepancy between balancing_log and balancing.txt is'
                            abs(bvariables(4)-balancing_log{...
                                balancing_log_row,14})/bvariables(4)
                        end
                    else
                        balancing_log{balancing_log_row,-2+4*i}=bvariables(i);
                    end
                end
            %check te0 convergence
            gvariable=balancing_log{balancing_log_row,15};
            mvariable=balancing_log{balancing_log_row,13};
            [converged_ans]=jpf2_balancer_2014_convergence_checker(...
                gvariable,mvariable,4);
            if converged_ans==1
                te0_convergence=1
                balancing_log{balancing_log_row,16}=1;
            else
                te0_convergence=0;
            end
            %write balancing_log values to balancing_log.xls on correct line
            first_cell=strcat('A',num2str(balancing_log_row));
            xlswrite('balancing_log.xls',balancing_log(balancing_log_row...
                ,:),1,first_cell);
            %end te0 convergence check
            iterations_vector{8,2}=iterations_vector{8,2}+1
        end
        %88888888888888888888888888888888888888888888888888888888888888
        %end te0 convergence
        %88888888888888888888888888888888888888888888888888888888888888
        %
        %99999999999999999999999999999999999999999999999999999999999999
        %begin ped_temp convergence
        %99999999999999999999999999999999999999999999999999999999999999
        %check ped_temp convergence
        gvariable=balancing_log{balancing_log_row,19};
        mvariable=balancing_log{balancing_log_row,17};
        [converged_ans]=jpf2_balancer_2014_convergence_checker(gvariable...
            ,mvariable,5);
        if converged_ans==1
            ped_temp_convergence=1
            balancing_log{balancing_log_row,20}=ped_temp_convergence;
        else
            ped_temp_convergence=0;
        end
        %end ne20 convergence check
        %
        %start ne20 loop
        iterations_vector{9,2}=0;
        while ped_temp_convergence==0
                gvariable=balancing_log{balancing_log_row,19};
                mvariable=balancing_log{balancing_log_row,17};
                [increment,indicator]=jpf2_balancer_2014_incrementer(...
                    gvariable,mvariable,5);
                balancing_log_row=balancing_log_row+1;
                if iterations_vector{9,2}==0;
                    balancing_log{balancing_log_row,18}=balancing_log{...
                        balancing_log_row-1,18}*1.1;
                else
                    balancing_log{balancing_log_row,18}=balancing_log{...
                        balancing_log_row-1,18}*increment;
                    current_val=balancing_log{balancing_log_row,18};
                    if or(current_val<0.01,current_val>50)
                        display 'error, cballoon is greater than 50 or less than 0.01'
%                        pause
                    end
                end
                if diag_5==0
                    cballoon_pedtemp=[];
                    for i=0.1:0.5:25
                        [bvariables,mvariables]=jpf2_balancer_2014_GTEDGE_runner...
                            (5,i);
                        cballoon_pedtemp=[cballoon_pedtemp;i,mvariables(5)];
                        [i,mvariables(5)];
                    end
                    xlswrite('diagnostic_vector.xls',cballoon_pedtemp,'I1')
                    diag_5=1
                else
                end
                %run GTEDGE
                [bvariables,mvariables]=jpf2_balancer_2014_GTEDGE_runner...
                    (5,balancing_log{balancing_log_row,18});
                if or(mvariables(5)>50000,mvariables(5)<10)
                    display 'error, ped_temp is greater than 50 kev or less than 0.01 kev'
%                    pause
                end
                for i=1:5
                    balancing_log{balancing_log_row,-3+4*i}=mvariables(i);
                    balancing_log{balancing_log_row,-1+4*i}=balancing_log{...
                    balancing_log_row-1,-1+4*i};
                    if i==5
                        if balancing_log{balancing_log_row,18}<bvariables(5)*...
                            1.01 && balancing_log{balancing_log_row,18}>...
                            bvariables(5)*0.99
                        else display 'error - discrepancy between balancing_log and balancing.txt - line 259'
                        end
                    else
                        balancing_log{balancing_log_row,-2+4*i}=bvariables(i);
                    end
                end
            %check ped_temp convergence
            gvariable=balancing_log{balancing_log_row,19};
            mvariable=balancing_log{balancing_log_row,17};
            [converged_ans]=jpf2_balancer_2014_convergence_checker(...
                gvariable,mvariable,5);
            if converged_ans==1
                ped_temp_convergence=1
                balancing_log{balancing_log_row,20}=1;
            else
                ped_temp_convergence=0;
            end
            %write balancing_log values to balancing_log.xls on correct line
            first_cell=strcat('A',num2str(balancing_log_row));
            xlswrite('balancing_log.xls',balancing_log(balancing_log_row...
                ,:),1,first_cell);
            %end ped_temp convergence check
            iterations_vector{9,2}=iterations_vector{9,2}+1
        end
        %99999999999999999999999999999999999999999999999999999999999999
        %end ped_temp convergence
        %99999999999999999999999999999999999999999999999999999999999999
        %check temperatureconvergence
        %set temperature_convergence_vector for both variables
        for i=4:5
            gvariable=balancing_log{balancing_log_row,-1+4*i};
            mvariable=balancing_log{balancing_log_row,(-3+4*i)};
            [converged_ans]=jpf2_balancer_2014_convergence_checker(...
                gvariable,mvariable,i);
            %if converged, say so in the e20 convergence vector
            if converged_ans==1
                temperature_convergence_vector(i-3)=1;
            else temperature_convergence_vector(i-3)=1;
            end
        end
        %check for convergence
        if temperature_convergence_vector(1)==1 && ...
                temperature_convergence_vector(2)==1
            temperature_convergence=1
        else
            temperature_convergence=0;
        end
    iterations_vector{7,2}=iterations_vector{7,2}+1
    end
    %444444444444444444444444444444444444444444444444444444444444444444
    %end temperature convergence
    %444444444444444444444444444444444444444444444444444444444444444444
    %
    for i=1:5
        gvariable=balancing_log{balancing_log_row,-1+4*i};
        mvariable=balancing_log{balancing_log_row,(-3+4*i)};
        [converged_ans]=jpf2_balancer_2014_convergence_checker(...
            gvariable,mvariable,i);
        %if converged, say so in the e20 convergence vector
        if converged_ans==1
            convergence_vector(i)=1;
        else
            convergence_vector(i)=0;
        end
    end
    %check for convergence
    if convergence_vector(1)==1 && convergence_vector(2)==1 && ...
           convergence_vector(3)==1 && convergence_vector(4)==...
           1 && convergence_vector(5)==1
        outer_convergence=1
    else
        outer_convergence=0;
    end
    iterations_vector{1,2}=iterations_vector{1,2}+1
end
%11111111111111111111111111111111111111111111111111111111111111111111111111
%end outer convergence
%11111111111111111111111111111111111111111111111111111111111111111111111111
xlswrite('balancing_log_complete.xls',balancing_log);
end