function [bvariables,mvariables]=jpf2_balancer_2014_GTEDGE_runner(index,newvalue)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%writer
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if newvalue == 0
else
    namelist={'hconf','hrat','alphan','alphat2','cballoon'};

    balance=fileread('balance.txt');
    if isnumeric(newvalue)
        searchstring=strcat(namelist{index},'\s=\s-?\d*.\d*\s');
        newstring=strcat(namelist{index},{' '},'=',{' '},num2str(...
            newvalue),{' '});
        balance = regexprep(balance,searchstring,newstring);
    else
        display 'error, newvalue is not a number'
    end
        
    %write string to new balance.txt file
    temp_fileid = fopen('balance.txt','w');
    fwrite(temp_fileid,balance,'*char');
    fclose(temp_fileid);
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%runner
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%run GTEDGE and pause 2 second to allow run time
!soldivjpf2.exe > output.txt
pause(2)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%retriever
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%variables to be found
namelist={'hconf','hrat','alphan','alphat2','cballoon';'TAUE','LAV',...
    'central_ne','central_te','tped_avg'};

%loop to find balancing variable values in balance.txt, and assign them to 
%the bvariables vector
balance_string=fileread('balance.txt');

for i=1:5
    searchstring=strcat(namelist{1,i},'\s=\s(-?\d*\D\d*)');
    [value]=regexp(balance_string,searchstring,'tokens');
    bvariables(i)= str2double(value{1});
end

%loop to find moving variable values in pedestal.txt, and assign them to
%the mvariables vector
soldiv_string=fileread('soldiv.txt');

for i=1:5
    if i>2
      if i==5
          searchstring='PLASMA\sTEMPERATURE\s*(?:-?\d*\.\d*E\+?-?\d{1,2}\s*){4}(-?\d*\D\d*E\+?-?\d{1,2})';
          [value]=regexp(soldiv_string,searchstring,'tokens');
          mvariables(i)=str2double(value{1});
      else
          if i==3
              searchstring='CENTRAL\sNE=\s?(-?\d*\.\d*E\+-?\d{1,2})';
              [value]=regexp(soldiv_string,searchstring,'tokens');
              mvariables(i)=str2double(value{1})/1e20;
          else
              searchstring='CENTRAL\sTE=\s?(-?\d*\.\d*E\+-?\d{1,2})';
              [value]=regexp(soldiv_string,searchstring,'tokens');
              mvariables(i)=str2double(value{1});
          end
      end
    else
        if i==1
            [value]=regexp(soldiv_string,'TAUE=\s?\s?(-?\d*\.\d*)','tokens');
            mvariables(i)=str2double(value{1});
        else
            searchstring=strcat('LAV=\s?(-?\d*\.\d*E\+-?\d{1,2})');
            [value]=regexp(soldiv_string,searchstring,'tokens');
            mvariables(i)=str2double(value{1})/1e20;
        end
    end
end
end