Pro jpf2_getdata_2014b

close, /all

; define the shot number that the data will be retrieved for
shot = 144981

; call gadat2 to get the data points and time grids, and write them to variables
gadat2, time11, q95, 'q95', shot, xmin=2000, xmax=4000, tree='efit03'
gadat2, time12, major_radius, 'R0', shot, xmin=2000, xmax=4000, tree='efit03'
gadat2, time13, minor_radius, 'aminor', shot, xmin=2000, xmax=4000, tree='efit03'
gadat2, time14, elongation, 'kappa', shot, xmin=2000, xmax=4000, tree='efit03'
gadat2, time15, triangularity, 'tribot', shot, xmin=2000, xmax=4000, tree='efit03'
gadat2, time16, plasma_current, 'ipmeas', shot, xmin=2000, xmax=4000, tree='efit03'
gadat2, time17, btor, 'bcentr', shot, xmin=2000, xmax=4000, tree='efit03'
gadat2, time18, aux_power, 'pinj', shot, xmin=2000, xmax=4000
gadat2, time19, xpoint_r, 'rxpt1', shot, xmin=2000, xmax=4000, tree='efit03'
gadat2, time20, xpoint_z, 'zxpt1', shot, xmin=2000, xmax=4000, tree='efit03'
gadat2, time21, intcpt_rout, 'rvsout', shot, xmin=2000, xmax=4000, tree='efit03'
gadat2, time22, intcpt_rin, 'rvsin', shot, xmin=2000, xmax=4000, tree='efit03'
gadat2, time23, intcpt_zout, 'zvsout', shot, xmin=2000, xmax=4000, tree='efit03'
gadat2, time24, intcpt_zin, 'zvsin', shot, xmin=2000, xmax=4000, tree='efit03'
gadat2, time25, ssi95, 'ssi95', shot, xmin=2000, xmax=4000, tree='efit03'
gadat2, time26, ohmic_power, 'poh', shot, xmin=2000, xmax=4000, tree='efit03'
gadat2, time28, taumhd, 'taumhd', shot, xmin=2000, xmax=4000, tree='efit03'
; too many data points for line average density in EFIT03 to write to database...
gadat2, time27, lineavg_density, 'nebar_v2', shot, xmin=2000, xmax=4000, tree='efit03'


Openw, 1, '/u/floydjp/getdata/q95.txt', width=250
Openw, 2, '/u/floydjp/getdata/major_radius.txt', width=250
Openw, 3, '/u/floydjp/getdata/minor_radius.txt', width=250
Openw, 4, '/u/floydjp/getdata/elongation.txt', width=250
Openw, 5, '/u/floydjp/getdata/triangularity.txt', width=250
Openw, 6, '/u/floydjp/getdata/plasma_current.txt', width=250
Openw, 7, '/u/floydjp/getdata/btor.txt', width=250
Openw, 8, '/u/floydjp/getdata/aux_power.txt', width=250
Openw, 9, '/u/floydjp/getdata/xpoint_r.txt', width=250
Openw, 10, '/u/floydjp/getdata/xpoint_z.txt', width=250
Openw, 11, '/u/floydjp/getdata/intcpt_rout.txt', width=250
Openw, 12, '/u/floydjp/getdata/intcpt_rin.txt', width=250
Openw, 13, '/u/floydjp/getdata/intcpt_zout.txt', width=250
Openw, 14, '/u/floydjp/getdata/intcpt_zin.txt', width=250
Openw, 15, '/u/floydjp/getdata/ssi95.txt', width=250
Openw, 16, '/u/floydjp/getdata/ohmic_power.txt', width=250
Openw, 17, '/u/floydjp/getdata/lineavg_density.txt', width=250
Openw, 18, '/u/floydjp/getdata/taumhd.txt', width=250

common_length = SIZE(time11, /N_ELEMENTS)
density_length = SIZE(time27, /N_ELEMENTS)
paux_length = SIZE(time18, /N_ELEMENTS)
print, 'common length =', common_length, 'line average density length =', density_length, 'auxiliary power length =', paux_length


for i=0, common_length-1 do begin
printf, 1, time11[i], q95[i], format='(/f0, 2X, e0)
printf, 2, time12[i], major_radius[i], format='(/f0, 2X, e0)
printf, 3, time13[i], minor_radius[i], format='(/f0, 2X, e0)
printf, 4, time14[i], elongation[i], format='(/f0, 2X, e0)
printf, 5, time15[i], triangularity[i], format='(/f0, 2X, e0)
printf, 6, time16[i], plasma_current[i], format='(/f0, 2X, e0)
printf, 7, time17[i], btor[i], format='(/f0, 2X, e0)
printf, 9, time19[i], xpoint_r[i], format='(/f0, 2X, e0)
printf, 10, time20[i], xpoint_z[i], format='(/f0, 2X, e0)
printf, 11, time21[i], intcpt_rout[i], format='(/f0, 2X, e0)
printf, 12, time22[i], intcpt_rin[i], format='(/f0, 2X, e0)
printf, 13, time23[i], intcpt_zout[i], format='(/f0, 2X, e0)
printf, 14, time24[i], intcpt_zin[i], format='(/f0, 2X, e0)
printf, 15, time25[i], ssi95[i], format='(/f0, 2X, e0)
printf, 16, time26[i], ohmic_power[i], format='(/f0, 2X, e0)
printf, 18, time28[i], taumhd[i], format='(/f0, 2X, e0)
endfor

for i=0, density_length-1 do begin
printf, 17, time27[i], lineavg_density[i], format='(/f0, 2X, e0)
endfor

for i=0, paux_length-1 do begin
printf, 8, time18[i], aux_power[i], format='(/f0, 2X, e0)
endfor

close, /all

End