function jpf2_fitstoexcelplot_2014
%for this function to work, it must be in the same folder as all the .fit
%files 
%root file name
rootname = 'p144987_3225_'; %the underscore is for the file naming convention
%shot id's
shotid = {'jg725_', 'j254g_', 'j426g_', 'j608g_','j8g99_'};
%Variable names for the files
varnames = {'ersplrhob', 'ersplrhob_sc', 'fzsplrhob', 'fzsplrhob_sc',... 
    'netanhrhob', 'netanhrhob_sc', 'nisplrhob', 'nisplrhob_sc',... 
    'tetanhrhob', 'tetanhrhob_sc', 'tisplrhob', 'tisplrhob_sc',... 
    'vpolsplrhob', 'vpolsplrhob_sc', 'vtorsplrhob', 'vtorsplrhob_sc',...
    'dlnne_dt', 'dlnwe_dt', 'dlnwi_dt'};
nm1 = length(shotid);
nm2 = length(varnames);
%this part renames the time derivative files to .fit from .dat so that they
%can be implemented into this code
for i=17:nm2
    for j = 1:nm1
        oldname = strcat (rootname, shotid(j), varnames(i), '.dat');
        newname = strcat (rootname, shotid(j), varnames(i), '.fit');
        copyfile(char(oldname),char(newname));
    end
end
%This part defines a 3D matrix, by calling one of the .FIT file to
%get the number of rows
temp1 = strcat (rootname, shotid(1,1), varnames(1,3), '.fit');
temp1 = char(temp1);
temp2 = dlmread(temp1,'', 2,0);
[r,c] = size(temp2);
%remat structure:
%remat(*,*,n): n = 16, is the vector "varnames", rho + four shots for X
%varname
%remat(*,m,*): m = 5, 1st  column is rho, other four are vector "shotid",
%rho value and variable values at that rho for all 25 rho values and all
%16 variable names
%remat (o,*,*): o = 25 rho values.  gives variable value at each rho for
%all 16 variables at all four time slices
remat = zeros(r,nm1+1, nm2);
for i = 1:nm2
    fl = 0; %flag to get the data in the right column
    for j = 1:nm1
        var1 = strcat (rootname, shotid(1,j), varnames(1,i), '.fit');
        var1 = char(var1);
        matread = dlmread(var1, '', 2,0);
        if fl==0
            remat(1:r,1:2,i) = matread(1:r,1:2);
        else
            remat(:,fl+2,i) = matread(:,2);
        end
        fl=fl+1;
    end
end
temp3 = strcat (rootname,'data.xlsx');
temp3 = char(temp3);
% xmat = [];
% for i = 1:nm1
%     xmat = [xmat, shotid(1,i)];
% end
for k = 1:nm2
     xlswrite(temp3,remat(:,:,k), char(varnames(1,k)));
end
%plotting routine
e = actxserver('excel.application');
eWs = e.Workbooks;
eW = eWs.Open(fullfile(pwd,temp3));
%eW = eWs.Add;
for i = 1:nm2
    eSheets = eW.Sheets;
    eSheet1 = eSheets.get('Item', char(varnames(1,i)));
    eSheet1.Activate;
    eS = eW.ActiveSheet;
    e.Visible = 1;
    eCO = eS.ChartObjects.Add(100, 30, 400, 250);
    eC = eCO.Chart;
    for j = 1:nm1
     eC.SeriesCollection.NewSeries.Name = char(shotid(1,j));
     % better control of the data if the line number
     % is not your x-axis
     top = strcat(xlsColNum2Str(j+1),'2');
     bottom = strcat(xlsColNum2Str(j+1),'26');
     rng = char(strcat(top, ':', bottom));
     eC.SeriesCollection(j).Value = eS.Range(rng);
     eC.SeriesCollection(j).XValue = eS.Range('A2:A26');
    end
%eCO.Chart.ChartType = 1; % view the chart before moving on
%eCO.Chart.ChartType = 65; % view it again
%     eCO.Chart.HasTitle = true;
%     eCO.Chart.ChartTitle.Text = char(varnames(1,i));
    eC.ChartType = 'xlXYScatterLinesNoMarkers';
%     eC.Chart.axes(1).HasTitle = 1;
%     eC.Chart.axes(1).AxisTitle.Text = 'rho';
%     eC.Chart.axes(2).HasTitle = 1;
%     eC.Chart.axes(2).AxisTitle.Text = char(varnames(1,i));%change to 1,i
end
eW.Close;
e.Quit;
delete(e) 
end