function [] = jpf2_soldata_constructor_2014_144981_j203d
%for this function to work, it must be in the same folder as all the .fit
%files 
%root file name
rootname = 'p144981_3050_'; %the underscore is for the file naming convention
%shot id's
shotid = {'j001d_', 'j102d_', 'j203d_', 'j304d_', 'j406d_', 'j608d_',...
    'j8d99_'};
which_shotid = input('what shot_id is this soldata.for file representing','s')
%for soldata writing function, select shotid to write soldata.txt for
shotindex = strmatch(which_shotid,shotid);
soldata_shotid = shotid(shotindex);
display(strcat('soldata file created for: ',soldata_shotid))
%check to make sure soldata file is not already existing
newfilename = strcat(rootname,date,soldata_shotid,'.txt');
already_exist = exist(char(newfilename),'file');
if already_exist == 0 
    display('soldata file does not exist for this date, continuing')
else display('soldata file already exists.  To overwrite press any key')
    pause
end
%Variable names for the files, from the scripts
varnames = {'netanhrhob', 'netanhrhob_sc', 'vtorsplrhob_sc',...
    'tetanhrhob_sc', 'tisplrhob', 'tisplrhob_sc', 'tetanhrhob',...
    'ersplrhob', 'vpolsplrhob', 'vtorsplrhob', 'ersplrhob_sc',...
    'fzsplrhob', 'fzsplrhob_sc', 'nisplrhob', 'nisplrhob_sc',...
    'vpolsplrhob_sc', 'dlnne_dt', 'dlnwe_dt', 'dlnwi_dt'};
%variable names to be input into soldatatemplate.for, including vector and
%single number variables

%from MDSPlus
q95 = 3.49; %line 597
rmajor = 1.72; %line 775
aminor = 0.594; %line 776
elong = 1.74; %line 777
triang = 0.373; %line 778
plasmacur = 1.47; %line 782
%loop to make sure right value of Ip is input
if plasmacur < 1.0
    plasmacur = 1.0;
else
end
B = 2.11; %line 785
q95; %line 787
pbeam = 2.19; %line 788
Rx = 1.45; %line 791
zx = -1.14; %line 792
Rsep1 = 1.54; %line 793
rsep2 = 1.14; %line 794
zsep1 = -1.25; %line 795
zsep2 = -1.35; %line 796
ssi95 = 3.85; %line 797
pohmin = 0.732; %line 798
nebar_v2 = 7.77e19;
taumhd = 0.833; 

%from variable profiles
xnpedex = 7.0e19; %line 835
neped_rho = 0.958;
xnsepex = 8.0e18; %line 836
nesep_rho = 1.008;
ne0 = 1.2e20;
tpedexi = 666; %line 837
tiped_rho = 0.864; 
tsepexi = 340; %line 838
tisep_rho = 0.991;
ti0 = 2200;
tpedexe = 420; %line 839
teped_rho = 0.956;
tsepexe = 60; %line 840
tesep_rho = 0.9975;
te0 = 2300;

%calculated variables
widthnx = nesep_rho - neped_rho; %line 841
widthtex = tesep_rho - teped_rho; %line 842
widthtix = tisep_rho - tiped_rho; %line 843
gradnbar = 0.5 * widthnx * (xnpedex + xnsepex)/(xnpedex - xnsepex); %line 844 & 845
gradTbar = 0.5 * widthtix * (tpedexi + tsepexi)/(tpedexi - tsepexi); %line 846 & 847
gradTebar = 0.5 * widthtex * (tpedexe + tsepexe)/(tpedexi - tsepexi); %line 848 & 849
aped = xnpedex / nebar_v2; %line 850
xnctrped = ne0 / xnpedex; %line 851
tpedavg = (tpedexi + tpedexe)/2;
t0avg = (te0 + ti0)/2;
tctrped = t0avg/tpedavg; %line852
bphi = -1 * B; %line 786

%other variables
betag = 0.25; %line 789

varnames_vectors = {'netanhrhob', 'netanhrhob_sc', 'vtorsplrhob_sc',...
    'tetanhrhob_sc', 'tisplrhob', 'tisplrhob_sc', 'tetanhrhob',...
    'ersplrhob', 'vpolsplrhob', 'vtorsplrhob','dlnne_dt', 'dlnwe_dt',...
    'dlnwi_dt'};
soldata_varnames_vectors = {'EXNE', 'XLNE', 'exlv', 'EXLTE', 'XTI',...
    'EXLTI', 'XTE', 'erex', 'vthexp', 'torv', 'dlnn_dt', 'dlnwe_dt',...
    'dlnwi_dt'};
variable_units = {'e20','e0','e0','e0','e3','e0','e3','e3','e3','e3',...
    'e0','e0','e0'};
varnames_single = {'q95', 'rmajor', 'aminor', 'elong', 'triang',...
    'plasmacur', 'B', 'bphi', 'pbeam', 'betag', 'Rx', 'zx', 'Rsep1',...
    'rsep2', 'zsep1', 'zsep2', 'ssi95', 'pohmin', 'taumhd', 'nebar_v2',...
    'ne0', 'xnpedex', 'xnsepex', 'te0', 'tpedexe', 'tsepexe', 'ti0',...
    'tpedexi', 'tsepexi', 'tpedavg', 't0avg', 'widthnx', 'widthtex',...
    'widthtix',... %next is #35
    'gradnbar(3)','gradnbar(4)', 'gradTbar(3)', 'gradTbar(4)',...
    'gradTebar(3)', 'gradTebar(4)',...%next is #41
    'aped', 'xnctrped','tctrped'};
varnames_single_special = {'gradnbar\(3\)','gradnbar\(4\)',...
    'gradTbar\(3\)', 'gradTbar\(4\)', 'gradTebar\(3\)', 'gradTebar\(4\)'};
soldata_varnames_single = [q95, rmajor, aminor, elong, triang,...
    plasmacur, B, bphi, pbeam, betag, Rx, zx, Rsep1, rsep2, zsep1,...
    zsep2, ssi95, pohmin, taumhd, nebar_v2, ne0, xnpedex, xnsepex, te0,...
    tpedexe, tsepexe, ti0, tpedexi, tsepexi, tpedavg, t0avg, widthnx,...
    widthtex, widthtix , gradnbar, gradnbar, gradTbar, gradTbar,...
    gradTebar, gradTebar, aped, xnctrped, tctrped];
nm1 = length(shotid);
nm2 = length(varnames);
nm3 = length(varnames_vectors);
nm4 = length(soldata_varnames_vectors);
nm5 = length(varnames_single);
nm6 = length(soldata_varnames_single);
if and(nm3==nm4,nm5==nm6) disp('variable vectors lengths good')
else disp('warning, lengths of variable vectors do not match')
    pause
end
%this part renames the time derivative files to .fit from .dat so that they
%can be implemented into this code
for i=17:nm2
    for j = 1:nm1
        oldname = strcat (rootname, shotid(j), varnames(i), '.dat');
        newname = strcat (rootname, shotid(j), varnames(i), '.fit');
        copyfile(char(oldname),char(newname));
    end
end
%This part defines a 3D matrix, by calling one of the .FIT file to
%get the number of rows
temp1 = strcat (rootname, shotid(1,1), varnames(1,3), '.fit');
temp1 = char(temp1);
temp2 = dlmread(temp1,'', 2,0);
[r,c] = size(temp2);
%remat structure:
%remat(*,*,n): n = 16, is the vector "varnames", rho + four shots for X
%varname
%remat(*,m,*): m = 5, 1st  column is rho, other four are vector "shotid",
%rho value and variable values at that rho for all 25 rho values and all
%16 variable names
%remat (o,*,*): o = 25 rho values.  gives variable value at each rho for
%all 16 variables at all four time slices
remat = zeros(r,nm1+1, nm2);
for i = 1:nm2
    fl = 0; %flag to get the data in the right column
    for j = 1:nm1
        var1 = strcat (rootname, shotid(1,j), varnames(1,i), '.fit');
        var1 = char(var1);
        matread = dlmread(var1, '', 2, 0);
        varn = isnan(matread);%variable to store linear indexes of all NaN's in the matrix
        varch = any(any(varn));%to check if file has a NaN
        if varch==1
          disp(var1);
          disp('has a NaN using previous row entry as approximation');
          varn = find(varn);
          matread(varn) = matread (varn-1);
        end
        if fl==0
            remat(1:r,1:2,i) = matread(1:r,1:2);
        else
            remat(:,fl+2,i) = matread(:,2);
        end
        fl=fl+1;
    end    
end
%this part assigns values to the vector files in varnames, it assigns
%values from the remat 3d matrix containing the varnames values to the
%variables in varnames_vectors matrix, leaving out the rho values, and only
%taking the y values
var_values_vectors = zeros(r,nm4)
for i=1:length(varnames_vectors)
    if i>10
        time_deriv_index = i + 6;
        var_values_vectors(:,i) = remat(1:r,shotindex+1,time_deriv_index);
    else
        var_values_vectors(:,i)=remat(1:r,shotindex+1,i);
    end
end
var_values_vectors
%this part reads in the soldata file as a string for use of
%regexprep(r,s,t) which finds substring s in string r and replaces it with
%substring t.
soldatastr = fileread('soldatatemplate.for');
%these loops replace the vector values in soldata with the vector values
%from the script output files, by doing each variable, and all 25 values
%they use regular expressions to find the patterns in the string
for i=1:length(soldata_varnames_vectors)
    oldstrvarname = soldata_varnames_vectors(i);
    i
    for j=1:25
        array_loc = num2str(j);
        oldstrlabel = strcat(oldstrvarname,'\(',array_loc,'\)');
        var_value = num2str(var_values_vectors(j,i));
        searchstring = strcat(char(oldstrlabel),...
            '\s=\s-?\d*\.\d*([eE]-?\d\d?)?');
        newstring = strcat(char(oldstrvarname),'(',array_loc,')',{' '},...
            '=',{' '},num2str(var_value),char(variable_units(i)));
        %loop to take care of NaN's
        if and(j>1,strcmp(num2str(var_value),'NaN'));
            newstring = strcat(char(oldstrvarname),'(',array_loc,')',...
                {' '},'=',{' '},num2str(var_values_vectors(j-1,i)),...
                char(variable_units(i)));
            disp(strcat('NaN in variable',oldstrvarname,'replacing with'...
                ,'previous entry (in rho)'))
        else if and(j==1, strcmp(num2str(var_value),'NaN'));
                disp(strcat('error, NaN in first row of variable:',...
                    oldstrvarname));
                disp('press any key to continue run')
                pause
            else
            end
        end
        soldatastr = regexprep(soldatastr,searchstring,newstring);
        %just a status check
        if or(and(j==1,i==1),and(i==6,j==18))
            oldstrlabel
            searchstring
            newstring
        else
        end
    end
end
%replace single variable values in the input file with new values
for i=1:length(varnames_single)
    if or(i<35,i>40)
    searchstring_single = strcat(char(varnames_single(i)),...
        '\s=\s-?\d*\.\d*([eE]-?\d\d?)?');
    newstring_single = strcat(char(varnames_single(i)),{' '},'=',{' '},...
        num2str(soldata_varnames_single(i)));
%for the variable names with ( or ) in them    
    else searchstring_single = strcat(char(varnames_single_special...
            (i-34)),'\s=\s-?\d*\.\d*([eE]-?\d\d?)?');
        newstring_single = strcat(char(varnames_single(i)),{' '},'=',...
            {' '},num2str(soldata_varnames_single(i)));
    end
    soldatastr = regexprep(soldatastr,searchstring_single,newstring_single);
end
        
%write string to new soldata file with filename including shot, timeid, and
%date
temp_fileid = fopen(char(newfilename),'w');
fwrite(temp_fileid,soldatastr,'*char');
fclose(temp_fileid);
end
















